// Set up Raven
var dsn = 'https://366f412ff7664f44891889321c8925eb:ff8d68e117804bd28776c0c2ee3cb9b1@app.getsentry.com/4291';
var raven = require('../');
var client = new raven.Client(dsn);

// Express
var express = require('express');
var app = express();

// Views
var views = require('./views');

// Request middlewares
app.use(express.bodyParser());
app.use(express.cookieParser());
app.use(app.router);

// Exception middlewares
// Install the raven Express middleware
// and pass along your DSN
app.use(raven.middleware.express(client));
// Register an optional error handler *after* the raven
// middleware with access to res.sentry
app.use(function(err, req, res, next) {
  // Check if the Raven middleware has been hit
  if (res.sentry) {
    // If so, we want to give this error back to
    // our users
    res.end("We're sorry. :( " + res.sentry);
  }
  next(err);
});

// Routes
app.get('/broken', views.broken);

app.listen(3000);
console.log('Listening on port 3000');
