// Express
var express = require('express');
var app = express();

// Views
var views = require('./views');

// Request middlewares
app.use(express.bodyParser());
app.use(express.cookieParser());
app.use(app.router);

app.use(function(err, req, res, next) {
  // Check if the Raven middleware has been hit
  if (res.sentry) {
    // If so, we want to give this error back to
    // our users
    res.end("We're sorry. :( " + res.sentry);
  }
  next(err);
});

// Routes
app.get('/broken', views.broken);

app.listen(3000);
console.log('Listening on port 3000');
